//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: Simply examples in OpenACC
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
pgcc --version: 19.4-0 LLVM 64-bit target on x86-64 Linux -tp piledriver
OS:     Linux Ubuntu 18.04
CPU:    8-core, AMD FX(tm)-9370 Eight-Core Processor, 8801 BogoMips
*********************************************************************

Compiling:
pgcc  -Minfo=all accEx1.c -o accEx1 -fast
main:
     38, Loop not vectorized: may not be beneficial
     42, Generated vector simd code for the loop containing reductions

Output in my Laptop
Sum is 1300839.500000

real	0m0,032s
user	0m0,027s
sys	0m0,005s

*/

// ***************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <openacc.h>

#define N	1000000
float  	A[N] ;
// ***************************************************************
int main(int argc, char *argv[])
{

   for(int i=0; i < N ; i++)
     A[i] = cos((i%100000)*0.00001) + sin((i%100000)*0.00001);

   float sum=0;
   for(int i=0; i < N ; i++)
     sum += A[i];

   printf( "Sum is %f\n", sum );

   return 0;
}
