//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: Simply examples in OpenACC
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
pgcc --version: 19.4-0 LLVM 64-bit target on x86-64 Linux -tp piledriver
OS:     Linux Ubuntu 18.04
CPU:    8-core, AMD FX(tm)-9370 Eight-Core Processor, 8801 BogoMips
*********************************************************************

Compiling:
pgcc -acc -ta=tesla -Minfo=accel accEx3.c -o accEx3
main:
     40, Generating create(A[:])
     42, Generating present(A[:])
         Generating Tesla code
         43, #pragma acc loop gang, vector(128)
     46, Generating Tesla code
         47, #pragma acc loop gang, vector(128)
             Generating reduction(+:sum)
     46, Generating implicit copy(sum)
         Generating present(A[:])

Output in my Laptop
Sum is 1301166.750000

real	0m0,111s
user	0m0,021s
sys	0m0,088s
*/

// ***************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <openacc.h>

#define N	1000000
float  	A[N] ;
// ***************************************************************
int main(int argc, char *argv[])
{
float sum = 0 ;

#pragma acc data create(A[0:N]) copy(sum)
{
#pragma acc parallel loop present( A[0:N] )
   for(int i=0; i < N ; i++)
	A[i] = cos((i%100000)*0.00001) + sin((i%100000)*0.00001);

#pragma acc parallel loop present( A[0:N] ) reduction(+:sum)
   for(int i=0; i < N ; i++)
     sum += A[i];
}

   printf( "Sum is %f\n", sum );

   return 0; // normal exit
}
