//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: Simply examples in OpenACC
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
pgcc --version: 19.4-0 LLVM 64-bit target on x86-64 Linux -tp piledriver
OS:     Linux Ubuntu 18.04
CPU:    8-core, AMD FX(tm)-9370 Eight-Core Processor, 8801 BogoMips
*********************************************************************

Compiling:
pgcc -acc -ta=tesla:managed -Minfo=accel accEx4.c -o accEx4 -O3
main:
     53, Generating create(A[:1000000])
     55, Generating present(A[:1000000])
         Generating Tesla code
         56, #pragma acc loop gang, vector(128)
     59, Generating Tesla code
         60, #pragma acc loop gang, vector(128)
             Generating reduction(+:sum)
     59, Generating implicit copy(sum)
         Generating present(A[:1000000])

Output in my Laptop
Sum is 1301166.750000

real	0m0,175s
user	0m0,016s
sys	0m0,157s

*/

// ***************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <openacc.h>

#define N	1000000
float  	*A ;
// ***************************************************************
int main(int argc, char *argv[])
{
float sum = 0 ;

//acc_init(acc_device_nvidia);
//acc_set_device_num(0,acc_device_nvidia);

A = malloc( sizeof(float)) ;
#pragma acc data create(A[0:N])
{
#pragma acc parallel loop deviceptr(A)
   for(int i=0; i < N ; i++)
	A[i] = cos((i%100000)*0.00001) + sin((i%100000)*0.00001);

#pragma acc parallel loop deviceptr(A) reduction(+:sum)
   for(int i=0; i < N ; i++)
     sum += A[i];
}
//acc_shutdown(acc_device_nvidia);

   printf( "Sum is %f\n", sum );

   return 0; // normal exit
}
