//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: change Temperature in a plate
//      Author: Evangelos Dermatas
//      v0.1

/*
Vendor ID:           AuthenticAMD
CPU family:          21
Model:               2
Model name:          AMD FX(tm)-9370 Eight-Core Processor
CPU MHz:             1426.104
CPU max MHz:         4400,0000
CPU min MHz:         1400,0000
BogoMIPS:            8801.45

*********************************************************************
pgc++ 19.4-0 LLVM 64-bit target on x86-64 Linux -tp piledriver
OS:     Linux Ubuntu 18.04
CPU:    8-core, AMD FX(tm)-9370 Eight-Core Processor, 8801 BogoMips
*********************************************************************

*********************************************************************
Compiling:
pgc++ -acc -ta=tesla:managed -Minfo=accel accTempChang02.cpp -o accTempChang02 -O3

Output in my Laptop
Sum=1.5908e+06

real	0m0,424s
user	0m0,191s
sys	0m0,232s

*/


// ***************************************************************
#include <iostream>
#include <cstdlib>
// ***************************************************************

using namespace std;

#define N	1000
#define M	1000

float A[N][M] ;
float B[N][M] ;

// ***************************************************************
void initTemp(void)
{

float t = rand()%100 - 50 ;
#pragma acc parallel loop present(A[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
        A[i][0] = t ;

t = rand()%100 - 50 ;
#pragma acc parallel loop present(A[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
        A[i][M-1] = t ;

t = rand()%100 - 50 ;
#pragma acc parallel loop present(A[0:N][0:M])
for( int j = 0 ; j < M ; j++ )
        A[0][j] = t ;

t = rand()%100 - 50 ;
#pragma acc parallel loop present(A[0:N][0:M])
for( int j = 0 ; j < M ; j++ )
        A[N-1][j] = t ;

t = rand()%100 - 50 ;
#pragma acc parallel loop present(A[0:N][0:M])
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
        A[0][j] = t ;
}


// ***************************************************************
float computeTemp( int Time )
{
float sum = 0 ;

#pragma acc parallel loop present(A[0:N][0:M],B[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
        B[i][0] = A[i][0] ;

#pragma acc parallel loop present(A[0:N][0:M],B[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
        B[i][M-1] = A[i][M-1] ;

#pragma acc parallel loop present(A[0:N][0:M],B[0:N][0:M])
for( int j = 0 ; j < M ; j++ )
        B[0][j] = A[0][j] ;

#pragma acc parallel loop present(A[0:N][0:M],B[0:N][0:M])
for( int j = 0 ; j < M ; j++ )
        B[N-1][j] = A[N-1][j] ;

for(int k = 0 ; k< Time ; k++ )
{
#pragma acc parallel loop collapse(2) present(A[0:N][0:M],B[0:N][0:M])
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	B[i][j] = (A[i-1][j]+A[i+1][j]+A[i][j-1]+A[i][j+1]+2*A[i][j])/6.0 ;

#pragma acc parallel loop collapse(2) present(A[0:N][0:M],B[0:N][0:M])
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	A[i][j] = (B[i-1][j]+B[i+1][j]+B[i][j-1]+B[i][j+1]+2*B[i][j])/6.0 ;
}

#pragma acc parallel loop collapse(2) reduction(+:sum) present(A[0:N][0:M],B[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
for( int j = 0 ; j < M ; j++ )
	sum +=A[i][j];

return sum ;
}


// ***************************************************************
int main(int argc, char *argv[])
{
float t ;

#pragma acc enter data create(A[0:N][0:M],B[0:N][0:M])

initTemp() ;
t = computeTemp(1000) ;

#pragma acc exit data delete(A[0:N][0:M],B[0:N][0:M])

cout << "Sum=" << t << endl ;
   return 0;
}
